; ###########################################
; #               usburnGUI                 #
; # GUI fr usburn von Sprut (www.sprut.de) #
; ###########################################
;
;----- Includes einbinden -----

  IncludeFile "usburnGUI_var.pbi"
  IncludeFile "usburnGUI_procedures.pbi"

;
;----- Programmversion definieren -----
;  
  GL_Version$ = "0.6"

;
;----- Voreinstellungen laden -----
;
  ReadPreferences()
  ReadPICDatabase()
;
;----- Haupfenster ffnen -----
;
  OpenMainWindow()
  
  
  FillPICFamily()
    SetGadgetState(#ComboGadget_PICFamily, GL_Last_PIC_Fam)
      
  FillPICType(GetGadgetText(#ComboGadget_PICFamily))
    SetGadgetState(#ComboGadget_PICType, GL_Last_PIC)
    
    SetGadgetState(#ComboGadget_PICSocket, GL_Last_SOCKET)

  While WindowEvent() : Wend 

  PrintConsoleN("Searching for usburn ...")

  InitUSBURN()

;
;----- Hauptschleife -----
;
Repeat

  WindowEvent = WaitWindowEvent()
  
  EventGadget = EventGadget()
  
  EventMenu = EventMenu()
  
  EventType = EventType()
  
  If WindowEvent = #PB_Event_Gadget
    If EventGadget = #ButtonGadget_GetSourceHEX
      OpenHEX()
    
    ElseIf EventGadget = #ComboGadget_PICFamily
      If EventType = #PB_EventType_Change
        FillPICType(GetGadgetText(#ComboGadget_PICFamily))
      EndIf
    
    ElseIf EventGadget = #ComboGadget_PICType
      SetPICPins()  
    
    ElseIf EventGadget = #ButtonGadget_ActualizeGUIDB  
      SyncGUI_DB()
      FillPICFamily()
        SetGadgetState(#ComboGadget_PICFamily, 0)
      
      FillPICType(GetGadgetText(#ComboGadget_PICFamily))
    
    ElseIf EventGadget = #ButtonGadget_AutoDetect    
      AutodedectPIC()  
      While WindowEvent() : Wend
      
    ElseIf EventGadget = #ButtonGadget_FirmUpdate
      BurnFW()
    
    ElseIf EventGadget = #ButtonGadget_Calibrate
      Calibrate()
    
    ElseIf EventGadget = #ButtonGadget_WritePIC  
      Burn()
    
    ElseIf EventGadget = #ButtonGadget_ReadPIC
      ReadPIC()
      
    ElseIf  EventGadget = #ButtonGadget_ComparePIC
      ComparePIC()
      
    ElseIf  EventGadget = #ButtonGadget_Reanimate
      ReanimatePIC()
      
    ElseIf EventGadget = #ButtonGadget_TestBlank
      TestBlankPIC()
      
    ElseIf EventGadget = #ButtonGadget_ErasePIC
      ErasePIC()
      
    ElseIf EventGadget = #ButtonGadget_RemoveCP
      RemoveCP()
    
    ElseIf EventGadget = #ButtonGadget_RunPIC      
      RunPIC()
    
    ElseIf EventGadget = #ButtonGadget_Info
      Info()
    
    ElseIf EventGadget = #Button_DefinePath2usburn
      Path$ = PathRequester("Please select the path to usburn!", GL_usburnPath$)
      
      If Path$
        SetGadgetText(#String_usburn, Path$)
        GL_usburnPath$ = Path$
      
      EndIf
    
    ElseIf EventGadget = #FakeConsoleScroll
      GL_FakeConsole_ScrollStatus = GetGadgetState(#FakeConsoleScroll)
      
      RefreshFakeConsole()
      
      
    EndIf
    
  ElseIf WindowEvent = #PB_Event_Menu
    If EventMenu = 0
      If GetGadgetState(#Panel_Main) > 2
        RemoveGadgetItem(#Panel_Main, GetGadgetState(#Panel_Main))
        
      EndIf 
    EndIf
  EndIf
  
Until WindowEvent = #PB_Event_CloseWindow

SavePreferences()
WritePICDatabase()
; IDE Options = PureBasic 4.61 (Linux - x64)
; CursorPosition = 15
; FirstLine = 107
; EnableXP
; Executable = ../Releases/x64/0.6/usburnGUI
; CurrentDirectory = ../
; EnableExeConstant